#include <stdlib.h>
#include <iostream>
#include <iomanip>
using namespace std;

// решето Эратосфена 
// http://ru.wikipedia.org/wiki/%D0%E5%F8%E5%F2%EE_%DD%F0%E0%F2%EE%F1%F4%E5%ED%E0
// битовое решение

typedef long long type_t;                     // тип элементов массива может быть разный
//typedef char type_t;

static const uint size = sizeof( type_t );

void set( type_t arr[], ulong pos, bool val ) {
   ulong el = pos / size;
   type_t  sh = (type_t)1 << ( pos % size );  // (type_t)1 в записи очень важно!
   if( !val ) 
      arr[ el + 1 ] &= ~sh;
   else
      arr[ el + 1 ] |= sh;
}

bool get( type_t arr[], ulong pos ) {
   ulong el = pos / size;
   type_t  sh = (type_t)1 << ( pos % size );  // (type_t)1 в записи очень важно!
   return 0 != ( arr[ el + 1 ] & sh );
}

void eratos( type_t *arr, ulong size ) {
   ulong i, j;
   for( i = 2; i * i <= size; i += i > 2 ? 2 : 1 ) 
      if( get( arr, i ) ) 
         for( j = i * i; j < size; j += i )   // вычеркивание всех чисел кратных i 
            set( arr, j, false );
}

int main( int argc, char **argv ) {
   const int INLINE = 10;
   long n;
   while( 1 ) {
      cout << "граничное число: " << flush;
      cin >> n;
      ulong k, j;
      type_t *a = new type_t[ n / size + 1 ];
      for( k = 0; k <= n; k++ ) set( a, k, k > 1 );
      eratos( a, n );
      for( k = 0, j = 0; k <= n; k++, j += get( a, k ) ? 1 : 0 );
      cout << j << " простых чисел:" << endl;
      for( k = 0, j = 0; k <= n; k++ )
         if( get( a, k ) ) {
            j++;
            cout << setw( 5 ) << k << ( 0 == j % INLINE ? "\n" : "" );
         }
      if( j % INLINE != 0 ) cout << endl;
      delete [] a;
   }
   return 0;
}
