#include <stdlib.h>
#include <iostream>
#include <iomanip>
using namespace std;

// решето Эратосфена 
// http://ru.wikipedia.org/wiki/%D0%E5%F8%E5%F2%EE_%DD%F0%E0%F2%EE%F1%F4%E5%ED%E0

void eratos( bool *arr, ulong size ) {      // оптимизированный вариант
   ulong i, j;
   for( i = 2; i * i <= size; i += i > 2 ? 2 : 1 ) 
      if( arr[ i ] ) 
         for( j = i * i; j < size; j += i ) // вычеркивание всех чисел кратных i 
            arr[ j ] = false;
}

int main( int argc, char **argv ) {
   const int INLINE = 10;
   ulong n;                                 // верхний диапазон поиска
   while( 1 ) {
      cout << "граничное число: " << flush;
      cin >> n;
      bool *a = new bool [ n + 1 ];         // a[ n ] ? - n простое число
      ulong k, j;
      for( k = 0; k <= n; k++ )             // вычёркиваем 0, 1, остальные размечаем как простые 
         a[ k ] = k > 1; 
      eratos( a, n + 1 );
      for( k = 0, j = 0; k <= n; k++ )
         j += a[ k ] ? 1 : 0;
      cout << j << " простых чисел:" << endl;
      for( k = 0, j = 0; k <= n; k++ )
         if( a[ k ] ) {
            j++;
            cout << setw( 5 ) << k << ( 0 == j % INLINE ? "\n" : "" );
         }
      if( j % INLINE != 0 ) cout << endl;
      delete [] a;
   }
   return 0;
}
